Index: chan_mgcp.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_mgcp.c,v
retrieving revision 1.46
diff -p -2 -r1.46 chan_mgcp.c
*** chan_mgcp.c	26 Apr 2004 05:18:55 -0000	1.46
--- chan_mgcp.c	27 Apr 2004 14:55:24 -0000
***************
*** 45,48 ****
--- 45,51 ----
     -- embedded command support
  */
+ /* FS: Changes
+  * -- fixed reload_config() / do_monitor to stay responsive during reloads
+  */
  
  #include <stdio.h>
*************** static int mgcpsock_read(int *id, int fd
*** 3117,3120 ****
--- 3120,3125 ----
  }
  
+ static int *mgcpsock_read_id = NULL;
+ 
  static void *do_monitor(void *data)
  {
*************** static void *do_monitor(void *data)
*** 3127,3131 ****
  	/* Add an I/O event to our UDP socket */
  	if (mgcpsock > -1) 
! 		ast_io_add(io, mgcpsock, mgcpsock_read, AST_IO_IN, NULL);
  	
  	/* This thread monitors all the frame relay interfaces which are not yet in use
--- 3132,3136 ----
  	/* Add an I/O event to our UDP socket */
  	if (mgcpsock > -1) 
! 		mgcpsock_read_id = ast_io_add(io, mgcpsock, mgcpsock_read, AST_IO_IN, NULL);
  	
  	/* This thread monitors all the frame relay interfaces which are not yet in use
*************** static int reload_config(void)
*** 3866,3885 ****
  	while(cat) {
  		if (strcasecmp(cat, "general")) {
!             ast_mutex_lock(&gatelock);
  			g = build_gateway(cat, ast_variable_browse(cfg, cat));
  			if (g) {
  				if (option_verbose > 2) {
  					ast_verbose(VERBOSE_PREFIX_3 "Added gateway '%s'\n", g->name);
!                 }
!                 g->next = gateways;
!                 gateways = g;
  			}
-             ast_mutex_unlock(&gatelock);
  		}
  		cat = ast_category_browse(cfg, cat);
  	}
  
!     /* SC: prune deleted entries etc. */
!     prune_gateways();
  
  	if (ntohl(bindaddr.sin_addr.s_addr)) {
--- 3871,3896 ----
  	while(cat) {
  		if (strcasecmp(cat, "general")) {
! 	    		ast_mutex_lock(&gatelock);
  			g = build_gateway(cat, ast_variable_browse(cfg, cat));
  			if (g) {
  				if (option_verbose > 2) {
  					ast_verbose(VERBOSE_PREFIX_3 "Added gateway '%s'\n", g->name);
! 				}
! 				g->next = gateways;
! 				gateways = g;
! 			}
! 	    		ast_mutex_unlock(&gatelock);
! 
! 			/* FS: process queue and IO */
! 			if (monitor_thread == pthread_self()) {
! 				if (sched) ast_sched_wait(sched);
! 				if (io) ast_io_wait(io, 40);
  			}
  		}
  		cat = ast_category_browse(cfg, cat);
  	}
  
!     	/* SC: prune deleted entries etc. */
!     	prune_gateways();
  
  	if (ntohl(bindaddr.sin_addr.s_addr)) {
*************** static int reload_config(void)
*** 3900,3903 ****
--- 3911,3918 ----
  	if (mgcpsock > -1)
  		close(mgcpsock);
+ 
+ 	if (mgcpsock_read_id != NULL)
+ 		mgcpsock_read_id = ast_io_remove(io, mgcpsock_read_id);
+ 
  	mgcpsock = socket(AF_INET, SOCK_DGRAM, 0);
  	if (mgcpsock < 0) {
